;;;
;;;Part of: Vicare/OpenSSL
;;;Contents: OpenSSL constants
;;;Date: Sat Mar  9, 2013
;;;
;;;Abstract
;;;
;;;	Export an identifier syntax for each OpenSSL constant.
;;;
;;;Copyright (C) 2013 Marco Maggi <marco.maggi-ipsu@poste.it>
;;;
;;;This program is free software:  you can redistribute it and/or modify
;;;it under the terms of the  GNU General Public License as published by
;;;the Free Software Foundation, either version 3 of the License, or (at
;;;your option) any later version.
;;;
;;;This program is  distributed in the hope that it  will be useful, but
;;;WITHOUT  ANY   WARRANTY;  without   even  the  implied   warranty  of
;;;MERCHANTABILITY  or FITNESS FOR  A PARTICULAR  PURPOSE.  See  the GNU
;;;General Public License for more details.
;;;
;;;You should  have received  a copy of  the GNU General  Public License
;;;along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;;


(library (vicare crypto openssl constants)
  (export

    ;; EVP
    EVP_MAX_MD_SIZE
    EVP_MAX_KEY_LENGTH
    EVP_MAX_IV_LENGTH
    EVP_MAX_BLOCK_LENGTH

    PKCS5_SALT_LEN
    PKCS5_DEFAULT_ITER

    EVP_PK_RSA
    EVP_PK_DSA
    EVP_PK_DH
    EVP_PK_EC
    EVP_PKT_SIGN
    EVP_PKT_ENC
    EVP_PKT_EXCH
    EVP_PKS_RSA
    EVP_PKS_DSA
    EVP_PKS_EC
    EVP_PKT_EXP

    EVP_PKEY_NONE
    EVP_PKEY_RSA
    EVP_PKEY_RSA2
    EVP_PKEY_DSA
    EVP_PKEY_DSA1
    EVP_PKEY_DSA2
    EVP_PKEY_DSA3
    EVP_PKEY_DSA4
    EVP_PKEY_DH
    EVP_PKEY_EC
    EVP_PKEY_HMAC
    EVP_PKEY_CMAC

    EVP_PKEY_MO_SIGN
    EVP_PKEY_MO_VERIFY
    EVP_PKEY_MO_ENCRYPT
    EVP_PKEY_MO_DECRYPT

    EVP_MD_FLAG_ONESHOT
    EVP_MD_FLAG_PKEY_DIGEST
    EVP_MD_FLAG_PKEY_METHOD_SIGNATURE
    EVP_MD_FLAG_DIGALGID_MASK
    EVP_MD_FLAG_DIGALGID_NULL
    EVP_MD_FLAG_DIGALGID_ABSENT
    EVP_MD_FLAG_DIGALGID_CUSTOM
    EVP_MD_FLAG_FIPS
    EVP_MD_CTRL_DIGALGID
    EVP_MD_CTRL_MICALG
    EVP_MD_CTRL_ALG_CTRL

    EVP_MD_CTX_FLAG_ONESHOT
    EVP_MD_CTX_FLAG_CLEANED
    EVP_MD_CTX_FLAG_REUSE
    EVP_MD_CTX_FLAG_NON_FIPS_ALLOW
    EVP_MD_CTX_FLAG_PAD_MASK
    EVP_MD_CTX_FLAG_PAD_PKCS1
    EVP_MD_CTX_FLAG_PAD_X931
    EVP_MD_CTX_FLAG_PAD_PSS
    EVP_MD_CTX_FLAG_NO_INIT

    EVP_CIPH_STREAM_CIPHER
    EVP_CIPH_ECB_MODE
    EVP_CIPH_CBC_MODE
    EVP_CIPH_CFB_MODE
    EVP_CIPH_OFB_MODE
    EVP_CIPH_CTR_MODE
    EVP_CIPH_GCM_MODE
    EVP_CIPH_CCM_MODE
    EVP_CIPH_XTS_MODE
    EVP_CIPH_MODE
    EVP_CIPH_VARIABLE_LENGTH
    EVP_CIPH_CUSTOM_IV
    EVP_CIPH_ALWAYS_CALL_INIT
    EVP_CIPH_CTRL_INIT
    EVP_CIPH_CUSTOM_KEY_LENGTH
    EVP_CIPH_NO_PADDING
    EVP_CIPH_RAND_KEY
    EVP_CIPH_CUSTOM_COPY
    EVP_CIPH_FLAG_DEFAULT_ASN1
    EVP_CIPH_FLAG_LENGTH_BITS
    EVP_CIPH_FLAG_FIPS
    EVP_CIPH_FLAG_NON_FIPS_ALLOW
    EVP_CIPH_FLAG_CUSTOM_CIPHER
    EVP_CIPH_FLAG_AEAD_CIPHER

    EVP_CIPHER_ENCRYPT
    EVP_CIPHER_DECRYPT
    EVP_CIPHER_DEFAULT

    EVP_CTRL_INIT
    EVP_CTRL_SET_KEY_LENGTH
    EVP_CTRL_GET_RC2_KEY_BITS
    EVP_CTRL_SET_RC2_KEY_BITS
    EVP_CTRL_GET_RC5_ROUNDS
    EVP_CTRL_SET_RC5_ROUNDS
    EVP_CTRL_RAND_KEY
    EVP_CTRL_PBE_PRF_NID
    EVP_CTRL_COPY
    EVP_CTRL_GCM_SET_IVLEN
    EVP_CTRL_GCM_GET_TAG
    EVP_CTRL_GCM_SET_TAG
    EVP_CTRL_GCM_SET_IV_FIXED
    EVP_CTRL_GCM_IV_GEN
    EVP_CTRL_CCM_SET_IVLEN
    EVP_CTRL_CCM_GET_TAG
    EVP_CTRL_CCM_SET_TAG
    EVP_CTRL_CCM_SET_L
    EVP_CTRL_CCM_SET_MSGLEN
    EVP_CTRL_AEAD_TLS1_AAD
    EVP_CTRL_AEAD_SET_MAC_KEY
    EVP_CTRL_GCM_SET_IV_INV

    EVP_GCM_TLS_FIXED_IV_LEN
    EVP_GCM_TLS_EXPLICIT_IV_LEN
    EVP_GCM_TLS_TAG_LEN

    EVP_PBE_TYPE_OUTER
    EVP_PBE_TYPE_PRF

    ASN1_PKEY_ALIAS
    ASN1_PKEY_DYNAMIC
    ASN1_PKEY_SIGPARAM_NULL
    ASN1_PKEY_CTRL_PKCS7_SIGN
    ASN1_PKEY_CTRL_PKCS7_ENCRYPT
    ASN1_PKEY_CTRL_DEFAULT_MD_NID
    ASN1_PKEY_CTRL_CMS_SIGN
    ASN1_PKEY_CTRL_CMS_ENVELOPE

    EVP_PKEY_OP_UNDEFINED
    EVP_PKEY_OP_PARAMGEN
    EVP_PKEY_OP_KEYGEN
    EVP_PKEY_OP_SIGN
    EVP_PKEY_OP_VERIFY
    EVP_PKEY_OP_VERIFYRECOVER
    EVP_PKEY_OP_SIGNCTX
    EVP_PKEY_OP_VERIFYCTX
    EVP_PKEY_OP_ENCRYPT
    EVP_PKEY_OP_DECRYPT
    EVP_PKEY_OP_DERIVE
    EVP_PKEY_OP_TYPE_SIG
    EVP_PKEY_OP_TYPE_CRYPT
    EVP_PKEY_OP_TYPE_NOGEN
    EVP_PKEY_OP_TYPE_GEN

    EVP_PKEY_CTRL_MD
    EVP_PKEY_CTRL_PEER_KEY
    EVP_PKEY_CTRL_PKCS7_ENCRYPT
    EVP_PKEY_CTRL_PKCS7_DECRYPT
    EVP_PKEY_CTRL_PKCS7_SIGN
    EVP_PKEY_CTRL_SET_MAC_KEY
    EVP_PKEY_CTRL_DIGESTINIT
    EVP_PKEY_CTRL_SET_IV
    EVP_PKEY_CTRL_CMS_ENCRYPT
    EVP_PKEY_CTRL_CMS_DECRYPT
    EVP_PKEY_CTRL_CMS_SIGN
    EVP_PKEY_CTRL_CIPHER
    EVP_PKEY_ALG_CTRL
    EVP_PKEY_FLAG_AUTOARGLEN
    EVP_PKEY_FLAG_SIGCTX_CUSTOM

    EVP_F_AESNI_INIT_KEY
    EVP_F_AESNI_XTS_CIPHER
    EVP_F_AES_INIT_KEY
    EVP_F_AES_XTS
    EVP_F_AES_XTS_CIPHER
    EVP_F_ALG_MODULE_INIT
    EVP_F_CAMELLIA_INIT_KEY
    EVP_F_CMAC_INIT
    EVP_F_D2I_PKEY
    EVP_F_DO_SIGVER_INIT
    EVP_F_DSAPKEY2PKCS8
    EVP_F_DSA_PKEY2PKCS8
    EVP_F_ECDSA_PKEY2PKCS8
    EVP_F_ECKEY_PKEY2PKCS8
    EVP_F_EVP_CIPHERINIT_EX
    EVP_F_EVP_CIPHER_CTX_COPY
    EVP_F_EVP_CIPHER_CTX_CTRL
    EVP_F_EVP_CIPHER_CTX_SET_KEY_LENGTH
    EVP_F_EVP_DECRYPTFINAL_EX
    EVP_F_EVP_DIGESTINIT_EX
    EVP_F_EVP_ENCRYPTFINAL_EX
    EVP_F_EVP_MD_CTX_COPY_EX
    EVP_F_EVP_MD_SIZE
    EVP_F_EVP_OPENINIT
    EVP_F_EVP_PBE_ALG_ADD
    EVP_F_EVP_PBE_ALG_ADD_TYPE
    EVP_F_EVP_PBE_CIPHERINIT
    EVP_F_EVP_PKCS82PKEY
    EVP_F_EVP_PKCS82PKEY_BROKEN
    EVP_F_EVP_PKEY2PKCS8_BROKEN
    EVP_F_EVP_PKEY_COPY_PARAMETERS
    EVP_F_EVP_PKEY_CTX_CTRL
    EVP_F_EVP_PKEY_CTX_CTRL_STR
    EVP_F_EVP_PKEY_CTX_DUP
    EVP_F_EVP_PKEY_DECRYPT
    EVP_F_EVP_PKEY_DECRYPT_INIT
    EVP_F_EVP_PKEY_DECRYPT_OLD
    EVP_F_EVP_PKEY_DERIVE
    EVP_F_EVP_PKEY_DERIVE_INIT
    EVP_F_EVP_PKEY_DERIVE_SET_PEER
    EVP_F_EVP_PKEY_ENCRYPT
    EVP_F_EVP_PKEY_ENCRYPT_INIT
    EVP_F_EVP_PKEY_ENCRYPT_OLD
    EVP_F_EVP_PKEY_GET1_DH
    EVP_F_EVP_PKEY_GET1_DSA
    EVP_F_EVP_PKEY_GET1_ECDSA
    EVP_F_EVP_PKEY_GET1_EC_KEY
    EVP_F_EVP_PKEY_GET1_RSA
    EVP_F_EVP_PKEY_KEYGEN
    EVP_F_EVP_PKEY_KEYGEN_INIT
    EVP_F_EVP_PKEY_NEW
    EVP_F_EVP_PKEY_PARAMGEN
    EVP_F_EVP_PKEY_PARAMGEN_INIT
    EVP_F_EVP_PKEY_SIGN
    EVP_F_EVP_PKEY_SIGN_INIT
    EVP_F_EVP_PKEY_VERIFY
    EVP_F_EVP_PKEY_VERIFY_INIT
    EVP_F_EVP_PKEY_VERIFY_RECOVER
    EVP_F_EVP_PKEY_VERIFY_RECOVER_INIT
    EVP_F_EVP_RIJNDAEL
    EVP_F_EVP_SIGNFINAL
    EVP_F_EVP_VERIFYFINAL
    EVP_F_FIPS_CIPHERINIT
    EVP_F_FIPS_CIPHER_CTX_COPY
    EVP_F_FIPS_CIPHER_CTX_CTRL
    EVP_F_FIPS_CIPHER_CTX_SET_KEY_LENGTH
    EVP_F_FIPS_DIGESTINIT
    EVP_F_FIPS_MD_CTX_COPY
    EVP_F_HMAC_INIT_EX
    EVP_F_INT_CTX_NEW
    EVP_F_PKCS5_PBE_KEYIVGEN
    EVP_F_PKCS5_V2_PBE_KEYIVGEN
    EVP_F_PKCS5_V2_PBKDF2_KEYIVGEN
    EVP_F_PKCS8_SET_BROKEN
    EVP_F_PKEY_SET_TYPE
    EVP_F_RC2_MAGIC_TO_METH
    EVP_F_RC5_CTRL

    EVP_R_AES_IV_SETUP_FAILED
    EVP_R_AES_KEY_SETUP_FAILED
    EVP_R_ASN1_LIB
    EVP_R_BAD_BLOCK_LENGTH
    EVP_R_BAD_DECRYPT
    EVP_R_BAD_KEY_LENGTH
    EVP_R_BN_DECODE_ERROR
    EVP_R_BN_PUBKEY_ERROR
    EVP_R_BUFFER_TOO_SMALL
    EVP_R_CAMELLIA_KEY_SETUP_FAILED
    EVP_R_CIPHER_PARAMETER_ERROR
    EVP_R_COMMAND_NOT_SUPPORTED
    EVP_R_CTRL_NOT_IMPLEMENTED
    EVP_R_CTRL_OPERATION_NOT_IMPLEMENTED
    EVP_R_DATA_NOT_MULTIPLE_OF_BLOCK_LENGTH
    EVP_R_DECODE_ERROR
    EVP_R_DIFFERENT_KEY_TYPES
    EVP_R_DIFFERENT_PARAMETERS
    EVP_R_DISABLED_FOR_FIPS
    EVP_R_ENCODE_ERROR
    EVP_R_ERROR_LOADING_SECTION
    EVP_R_ERROR_SETTING_FIPS_MODE
    EVP_R_EVP_PBE_CIPHERINIT_ERROR
    EVP_R_EXPECTING_AN_RSA_KEY
    EVP_R_EXPECTING_A_DH_KEY
    EVP_R_EXPECTING_A_DSA_KEY
    EVP_R_EXPECTING_A_ECDSA_KEY
    EVP_R_EXPECTING_A_EC_KEY
    EVP_R_FIPS_MODE_NOT_SUPPORTED
    EVP_R_INITIALIZATION_ERROR
    EVP_R_INPUT_NOT_INITIALIZED
    EVP_R_INVALID_DIGEST
    EVP_R_INVALID_FIPS_MODE
    EVP_R_INVALID_KEY_LENGTH
    EVP_R_INVALID_OPERATION
    EVP_R_IV_TOO_LARGE
    EVP_R_KEYGEN_FAILURE
    EVP_R_MESSAGE_DIGEST_IS_NULL
    EVP_R_METHOD_NOT_SUPPORTED
    EVP_R_MISSING_PARAMETERS
    EVP_R_NO_CIPHER_SET
    EVP_R_NO_DEFAULT_DIGEST
    EVP_R_NO_DIGEST_SET
    EVP_R_NO_DSA_PARAMETERS
    EVP_R_NO_KEY_SET
    EVP_R_NO_OPERATION_SET
    EVP_R_NO_SIGN_FUNCTION_CONFIGURED
    EVP_R_NO_VERIFY_FUNCTION_CONFIGURED
    EVP_R_OPERATION_NOT_SUPPORTED_FOR_THIS_KEYTYPE
    EVP_R_OPERATON_NOT_INITIALIZED
    EVP_R_PKCS8_UNKNOWN_BROKEN_TYPE
    EVP_R_PRIVATE_KEY_DECODE_ERROR
    EVP_R_PRIVATE_KEY_ENCODE_ERROR
    EVP_R_PUBLIC_KEY_NOT_RSA
    EVP_R_TOO_LARGE
    EVP_R_UNKNOWN_CIPHER
    EVP_R_UNKNOWN_DIGEST
    EVP_R_UNKNOWN_OPTION
    EVP_R_UNKNOWN_PBE_ALGORITHM
    EVP_R_UNSUPORTED_NUMBER_OF_ROUNDS
    EVP_R_UNSUPPORTED_ALGORITHM
    EVP_R_UNSUPPORTED_CIPHER
    EVP_R_UNSUPPORTED_KEYLENGTH
    EVP_R_UNSUPPORTED_KEY_DERIVATION_FUNCTION
    EVP_R_UNSUPPORTED_KEY_SIZE
    EVP_R_UNSUPPORTED_PRF
    EVP_R_UNSUPPORTED_PRIVATE_KEY_ALGORITHM
    EVP_R_UNSUPPORTED_SALT_TYPE
    EVP_R_WRONG_FINAL_BLOCK_LENGTH
    EVP_R_WRONG_PUBLIC_KEY_TYPE

    ;; Message Digest 4
    MD4_DIGEST_LENGTH

    ;; Message Digest 5
    MD5_DIGEST_LENGTH

    ;; MDC2
    MDC2_DIGEST_LENGTH

    ;; SHA
    SHA_DIGEST_LENGTH
    SHA224_DIGEST_LENGTH
    SHA256_DIGEST_LENGTH
    SHA384_DIGEST_LENGTH
    SHA512_DIGEST_LENGTH

    ;; RIPEMD 160
    RIPEMD160_DIGEST_LENGTH

    ;; WHIRLPOOL
    WHIRLPOOL_DIGEST_LENGTH

    ;; HMAC
    HMAC_MAX_MD_CBLOCK

    ;; AES
    AES_ENCRYPT AES_DECRYPT AES_BLOCK_SIZE

    ;; buffers
    BUF_F_BUF_MEMDUP		BUF_F_BUF_MEM_GROW		BUF_F_BUF_MEM_GROW_CLEAN
    BUF_F_BUF_MEM_NEW		BUF_F_BUF_STRDUP		BUF_F_BUF_STRNDUP
    )
  (import (rename (only (vicare)
			define-inline-constant)
		  (define-inline-constant	defc)))


;;;; EVP

(defc EVP_CIPHER_ENCRYPT	+1)
(defc EVP_CIPHER_DECRYPT	0)
(defc EVP_CIPHER_DEFAULT	-1)

(defc EVP_MAX_MD_SIZE
  64)
(defc EVP_MAX_KEY_LENGTH
  64)
(defc EVP_MAX_IV_LENGTH
  16)
(defc EVP_MAX_BLOCK_LENGTH
  32)

(defc PKCS5_SALT_LEN
  8)
(defc PKCS5_DEFAULT_ITER
  2048)

(defc EVP_PK_RSA
  1)
(defc EVP_PK_DSA
  2)
(defc EVP_PK_DH
  4)
(defc EVP_PK_EC
  8)
(defc EVP_PKT_SIGN
  16)
(defc EVP_PKT_ENC
  32)
(defc EVP_PKT_EXCH
  64)
(defc EVP_PKS_RSA
  256)
(defc EVP_PKS_DSA
  512)
(defc EVP_PKS_EC
  1024)
(defc EVP_PKT_EXP
  #f)

(defc EVP_PKEY_NONE
  0)
(defc EVP_PKEY_RSA
  6)
(defc EVP_PKEY_RSA2
  19)
(defc EVP_PKEY_DSA
  116)
(defc EVP_PKEY_DSA1
  67)
(defc EVP_PKEY_DSA2
  66)
(defc EVP_PKEY_DSA3
  113)
(defc EVP_PKEY_DSA4
  70)
(defc EVP_PKEY_DH
  28)
(defc EVP_PKEY_EC
  408)
(defc EVP_PKEY_HMAC
  855)
(defc EVP_PKEY_CMAC
  894)

(defc EVP_PKEY_MO_SIGN
  1)
(defc EVP_PKEY_MO_VERIFY
  2)
(defc EVP_PKEY_MO_ENCRYPT
  4)
(defc EVP_PKEY_MO_DECRYPT
  8)

(defc EVP_MD_FLAG_ONESHOT
  1)
(defc EVP_MD_FLAG_PKEY_DIGEST
  2)
(defc EVP_MD_FLAG_PKEY_METHOD_SIGNATURE
  4)
(defc EVP_MD_FLAG_DIGALGID_MASK
  24)
(defc EVP_MD_FLAG_DIGALGID_NULL
  0)
(defc EVP_MD_FLAG_DIGALGID_ABSENT
  8)
(defc EVP_MD_FLAG_DIGALGID_CUSTOM
  24)
(defc EVP_MD_FLAG_FIPS
  1024)
(defc EVP_MD_CTRL_DIGALGID
  1)
(defc EVP_MD_CTRL_MICALG
  2)
(defc EVP_MD_CTRL_ALG_CTRL
  4096)

(defc EVP_MD_CTX_FLAG_ONESHOT
  1)
(defc EVP_MD_CTX_FLAG_CLEANED
  2)
(defc EVP_MD_CTX_FLAG_REUSE
  4)
(defc EVP_MD_CTX_FLAG_NON_FIPS_ALLOW
  8)
(defc EVP_MD_CTX_FLAG_PAD_MASK
  240)
(defc EVP_MD_CTX_FLAG_PAD_PKCS1
  0)
(defc EVP_MD_CTX_FLAG_PAD_X931
  16)
(defc EVP_MD_CTX_FLAG_PAD_PSS
  32)
(defc EVP_MD_CTX_FLAG_NO_INIT
  256)

(defc EVP_CIPH_STREAM_CIPHER
  0)
(defc EVP_CIPH_ECB_MODE
  1)
(defc EVP_CIPH_CBC_MODE
  2)
(defc EVP_CIPH_CFB_MODE
  3)
(defc EVP_CIPH_OFB_MODE
  4)
(defc EVP_CIPH_CTR_MODE
  5)
(defc EVP_CIPH_GCM_MODE
  6)
(defc EVP_CIPH_CCM_MODE
  7)
(defc EVP_CIPH_XTS_MODE
  65537)
(defc EVP_CIPH_MODE
  983047)
(defc EVP_CIPH_VARIABLE_LENGTH
  8)
(defc EVP_CIPH_CUSTOM_IV
  16)
(defc EVP_CIPH_ALWAYS_CALL_INIT
  32)
(defc EVP_CIPH_CTRL_INIT
  64)
(defc EVP_CIPH_CUSTOM_KEY_LENGTH
  128)
(defc EVP_CIPH_NO_PADDING
  256)
(defc EVP_CIPH_RAND_KEY
  512)
(defc EVP_CIPH_CUSTOM_COPY
  1024)
(defc EVP_CIPH_FLAG_DEFAULT_ASN1
  4096)
(defc EVP_CIPH_FLAG_LENGTH_BITS
  8192)
(defc EVP_CIPH_FLAG_FIPS
  16384)
(defc EVP_CIPH_FLAG_NON_FIPS_ALLOW
  32768)
(defc EVP_CIPH_FLAG_CUSTOM_CIPHER
  1048576)
(defc EVP_CIPH_FLAG_AEAD_CIPHER
  2097152)

(defc EVP_CTRL_INIT
  0)
(defc EVP_CTRL_SET_KEY_LENGTH
  1)
(defc EVP_CTRL_GET_RC2_KEY_BITS
  2)
(defc EVP_CTRL_SET_RC2_KEY_BITS
  3)
(defc EVP_CTRL_GET_RC5_ROUNDS
  4)
(defc EVP_CTRL_SET_RC5_ROUNDS
  5)
(defc EVP_CTRL_RAND_KEY
  6)
(defc EVP_CTRL_PBE_PRF_NID
  7)
(defc EVP_CTRL_COPY
  8)
(defc EVP_CTRL_GCM_SET_IVLEN
  9)
(defc EVP_CTRL_GCM_GET_TAG
  16)
(defc EVP_CTRL_GCM_SET_TAG
  17)
(defc EVP_CTRL_GCM_SET_IV_FIXED
  18)
(defc EVP_CTRL_GCM_IV_GEN
  19)
(defc EVP_CTRL_CCM_SET_IVLEN
  9)
(defc EVP_CTRL_CCM_GET_TAG
  16)
(defc EVP_CTRL_CCM_SET_TAG
  17)
(defc EVP_CTRL_CCM_SET_L
  20)
(defc EVP_CTRL_CCM_SET_MSGLEN
  21)
(defc EVP_CTRL_AEAD_TLS1_AAD
  22)
(defc EVP_CTRL_AEAD_SET_MAC_KEY
  23)
(defc EVP_CTRL_GCM_SET_IV_INV
  24)

(defc EVP_GCM_TLS_FIXED_IV_LEN
  4)
(defc EVP_GCM_TLS_EXPLICIT_IV_LEN
  8)
(defc EVP_GCM_TLS_TAG_LEN
  16)

(defc EVP_PBE_TYPE_OUTER
  0)
(defc EVP_PBE_TYPE_PRF
  1)

(defc ASN1_PKEY_ALIAS
  1)
(defc ASN1_PKEY_DYNAMIC
  2)
(defc ASN1_PKEY_SIGPARAM_NULL
  4)
(defc ASN1_PKEY_CTRL_PKCS7_SIGN
  1)
(defc ASN1_PKEY_CTRL_PKCS7_ENCRYPT
  2)
(defc ASN1_PKEY_CTRL_DEFAULT_MD_NID
  3)
(defc ASN1_PKEY_CTRL_CMS_SIGN
  5)
(defc ASN1_PKEY_CTRL_CMS_ENVELOPE
  7)

(defc EVP_PKEY_OP_UNDEFINED
  0)
(defc EVP_PKEY_OP_PARAMGEN
  2)
(defc EVP_PKEY_OP_KEYGEN
  4)
(defc EVP_PKEY_OP_SIGN
  8)
(defc EVP_PKEY_OP_VERIFY
  16)
(defc EVP_PKEY_OP_VERIFYRECOVER
  32)
(defc EVP_PKEY_OP_SIGNCTX
  64)
(defc EVP_PKEY_OP_VERIFYCTX
  128)
(defc EVP_PKEY_OP_ENCRYPT
  256)
(defc EVP_PKEY_OP_DECRYPT
  512)
(defc EVP_PKEY_OP_DERIVE
  1024)
(defc EVP_PKEY_OP_TYPE_SIG
  248)
(defc EVP_PKEY_OP_TYPE_CRYPT
  768)
(defc EVP_PKEY_OP_TYPE_NOGEN
  #f)
(defc EVP_PKEY_OP_TYPE_GEN
  6)

(defc EVP_PKEY_CTRL_MD
  1)
(defc EVP_PKEY_CTRL_PEER_KEY
  2)
(defc EVP_PKEY_CTRL_PKCS7_ENCRYPT
  3)
(defc EVP_PKEY_CTRL_PKCS7_DECRYPT
  4)
(defc EVP_PKEY_CTRL_PKCS7_SIGN
  5)
(defc EVP_PKEY_CTRL_SET_MAC_KEY
  6)
(defc EVP_PKEY_CTRL_DIGESTINIT
  7)
(defc EVP_PKEY_CTRL_SET_IV
  8)
(defc EVP_PKEY_CTRL_CMS_ENCRYPT
  9)
(defc EVP_PKEY_CTRL_CMS_DECRYPT
  10)
(defc EVP_PKEY_CTRL_CMS_SIGN
  11)
(defc EVP_PKEY_CTRL_CIPHER
  12)
(defc EVP_PKEY_ALG_CTRL
  4096)
(defc EVP_PKEY_FLAG_AUTOARGLEN
  2)
(defc EVP_PKEY_FLAG_SIGCTX_CUSTOM
  4)

(defc EVP_F_AESNI_INIT_KEY
  165)
(defc EVP_F_AESNI_XTS_CIPHER
  176)
(defc EVP_F_AES_INIT_KEY
  133)
(defc EVP_F_AES_XTS
  172)
(defc EVP_F_AES_XTS_CIPHER
  175)
(defc EVP_F_ALG_MODULE_INIT
  177)
(defc EVP_F_CAMELLIA_INIT_KEY
  159)
(defc EVP_F_CMAC_INIT
  173)
(defc EVP_F_D2I_PKEY
  100)
(defc EVP_F_DO_SIGVER_INIT
  161)
(defc EVP_F_DSAPKEY2PKCS8
  134)
(defc EVP_F_DSA_PKEY2PKCS8
  135)
(defc EVP_F_ECDSA_PKEY2PKCS8
  129)
(defc EVP_F_ECKEY_PKEY2PKCS8
  132)
(defc EVP_F_EVP_CIPHERINIT_EX
  123)
(defc EVP_F_EVP_CIPHER_CTX_COPY
  163)
(defc EVP_F_EVP_CIPHER_CTX_CTRL
  124)
(defc EVP_F_EVP_CIPHER_CTX_SET_KEY_LENGTH
  122)
(defc EVP_F_EVP_DECRYPTFINAL_EX
  101)
(defc EVP_F_EVP_DIGESTINIT_EX
  128)
(defc EVP_F_EVP_ENCRYPTFINAL_EX
  127)
(defc EVP_F_EVP_MD_CTX_COPY_EX
  110)
(defc EVP_F_EVP_MD_SIZE
  162)
(defc EVP_F_EVP_OPENINIT
  102)
(defc EVP_F_EVP_PBE_ALG_ADD
  115)
(defc EVP_F_EVP_PBE_ALG_ADD_TYPE
  160)
(defc EVP_F_EVP_PBE_CIPHERINIT
  116)
(defc EVP_F_EVP_PKCS82PKEY
  111)
(defc EVP_F_EVP_PKCS82PKEY_BROKEN
  136)
(defc EVP_F_EVP_PKEY2PKCS8_BROKEN
  113)
(defc EVP_F_EVP_PKEY_COPY_PARAMETERS
  103)
(defc EVP_F_EVP_PKEY_CTX_CTRL
  137)
(defc EVP_F_EVP_PKEY_CTX_CTRL_STR
  150)
(defc EVP_F_EVP_PKEY_CTX_DUP
  156)
(defc EVP_F_EVP_PKEY_DECRYPT
  104)
(defc EVP_F_EVP_PKEY_DECRYPT_INIT
  138)
(defc EVP_F_EVP_PKEY_DECRYPT_OLD
  151)
(defc EVP_F_EVP_PKEY_DERIVE
  153)
(defc EVP_F_EVP_PKEY_DERIVE_INIT
  154)
(defc EVP_F_EVP_PKEY_DERIVE_SET_PEER
  155)
(defc EVP_F_EVP_PKEY_ENCRYPT
  105)
(defc EVP_F_EVP_PKEY_ENCRYPT_INIT
  139)
(defc EVP_F_EVP_PKEY_ENCRYPT_OLD
  152)
(defc EVP_F_EVP_PKEY_GET1_DH
  119)
(defc EVP_F_EVP_PKEY_GET1_DSA
  120)
(defc EVP_F_EVP_PKEY_GET1_ECDSA
  130)
(defc EVP_F_EVP_PKEY_GET1_EC_KEY
  131)
(defc EVP_F_EVP_PKEY_GET1_RSA
  121)
(defc EVP_F_EVP_PKEY_KEYGEN
  146)
(defc EVP_F_EVP_PKEY_KEYGEN_INIT
  147)
(defc EVP_F_EVP_PKEY_NEW
  106)
(defc EVP_F_EVP_PKEY_PARAMGEN
  148)
(defc EVP_F_EVP_PKEY_PARAMGEN_INIT
  149)
(defc EVP_F_EVP_PKEY_SIGN
  140)
(defc EVP_F_EVP_PKEY_SIGN_INIT
  141)
(defc EVP_F_EVP_PKEY_VERIFY
  142)
(defc EVP_F_EVP_PKEY_VERIFY_INIT
  143)
(defc EVP_F_EVP_PKEY_VERIFY_RECOVER
  144)
(defc EVP_F_EVP_PKEY_VERIFY_RECOVER_INIT
  145)
(defc EVP_F_EVP_RIJNDAEL
  126)
(defc EVP_F_EVP_SIGNFINAL
  107)
(defc EVP_F_EVP_VERIFYFINAL
  108)
(defc EVP_F_FIPS_CIPHERINIT
  166)
(defc EVP_F_FIPS_CIPHER_CTX_COPY
  170)
(defc EVP_F_FIPS_CIPHER_CTX_CTRL
  167)
(defc EVP_F_FIPS_CIPHER_CTX_SET_KEY_LENGTH
  171)
(defc EVP_F_FIPS_DIGESTINIT
  168)
(defc EVP_F_FIPS_MD_CTX_COPY
  169)
(defc EVP_F_HMAC_INIT_EX
  174)
(defc EVP_F_INT_CTX_NEW
  157)
(defc EVP_F_PKCS5_PBE_KEYIVGEN
  117)
(defc EVP_F_PKCS5_V2_PBE_KEYIVGEN
  118)
(defc EVP_F_PKCS5_V2_PBKDF2_KEYIVGEN
  164)
(defc EVP_F_PKCS8_SET_BROKEN
  112)
(defc EVP_F_PKEY_SET_TYPE
  158)
(defc EVP_F_RC2_MAGIC_TO_METH
  109)
(defc EVP_F_RC5_CTRL
  125)

(defc EVP_R_AES_IV_SETUP_FAILED
  162)
(defc EVP_R_AES_KEY_SETUP_FAILED
  143)
(defc EVP_R_ASN1_LIB
  140)
(defc EVP_R_BAD_BLOCK_LENGTH
  136)
(defc EVP_R_BAD_DECRYPT
  100)
(defc EVP_R_BAD_KEY_LENGTH
  137)
(defc EVP_R_BN_DECODE_ERROR
  112)
(defc EVP_R_BN_PUBKEY_ERROR
  113)
(defc EVP_R_BUFFER_TOO_SMALL
  155)
(defc EVP_R_CAMELLIA_KEY_SETUP_FAILED
  157)
(defc EVP_R_CIPHER_PARAMETER_ERROR
  122)
(defc EVP_R_COMMAND_NOT_SUPPORTED
  147)
(defc EVP_R_CTRL_NOT_IMPLEMENTED
  132)
(defc EVP_R_CTRL_OPERATION_NOT_IMPLEMENTED
  133)
(defc EVP_R_DATA_NOT_MULTIPLE_OF_BLOCK_LENGTH
  138)
(defc EVP_R_DECODE_ERROR
  114)
(defc EVP_R_DIFFERENT_KEY_TYPES
  101)
(defc EVP_R_DIFFERENT_PARAMETERS
  153)
(defc EVP_R_DISABLED_FOR_FIPS
  163)
(defc EVP_R_ENCODE_ERROR
  115)
(defc EVP_R_ERROR_LOADING_SECTION
  165)
(defc EVP_R_ERROR_SETTING_FIPS_MODE
  166)
(defc EVP_R_EVP_PBE_CIPHERINIT_ERROR
  119)
(defc EVP_R_EXPECTING_AN_RSA_KEY
  127)
(defc EVP_R_EXPECTING_A_DH_KEY
  128)
(defc EVP_R_EXPECTING_A_DSA_KEY
  129)
(defc EVP_R_EXPECTING_A_ECDSA_KEY
  141)
(defc EVP_R_EXPECTING_A_EC_KEY
  142)
(defc EVP_R_FIPS_MODE_NOT_SUPPORTED
  167)
(defc EVP_R_INITIALIZATION_ERROR
  134)
(defc EVP_R_INPUT_NOT_INITIALIZED
  111)
(defc EVP_R_INVALID_DIGEST
  152)
(defc EVP_R_INVALID_FIPS_MODE
  168)
(defc EVP_R_INVALID_KEY_LENGTH
  130)
(defc EVP_R_INVALID_OPERATION
  148)
(defc EVP_R_IV_TOO_LARGE
  102)
(defc EVP_R_KEYGEN_FAILURE
  120)
(defc EVP_R_MESSAGE_DIGEST_IS_NULL
  159)
(defc EVP_R_METHOD_NOT_SUPPORTED
  144)
(defc EVP_R_MISSING_PARAMETERS
  103)
(defc EVP_R_NO_CIPHER_SET
  131)
(defc EVP_R_NO_DEFAULT_DIGEST
  158)
(defc EVP_R_NO_DIGEST_SET
  139)
(defc EVP_R_NO_DSA_PARAMETERS
  116)
(defc EVP_R_NO_KEY_SET
  154)
(defc EVP_R_NO_OPERATION_SET
  149)
(defc EVP_R_NO_SIGN_FUNCTION_CONFIGURED
  104)
(defc EVP_R_NO_VERIFY_FUNCTION_CONFIGURED
  105)
(defc EVP_R_OPERATION_NOT_SUPPORTED_FOR_THIS_KEYTYPE
  150)
(defc EVP_R_OPERATON_NOT_INITIALIZED
  151)
(defc EVP_R_PKCS8_UNKNOWN_BROKEN_TYPE
  117)
(defc EVP_R_PRIVATE_KEY_DECODE_ERROR
  145)
(defc EVP_R_PRIVATE_KEY_ENCODE_ERROR
  146)
(defc EVP_R_PUBLIC_KEY_NOT_RSA
  106)
(defc EVP_R_TOO_LARGE
  164)
(defc EVP_R_UNKNOWN_CIPHER
  160)
(defc EVP_R_UNKNOWN_DIGEST
  161)
(defc EVP_R_UNKNOWN_OPTION
  169)
(defc EVP_R_UNKNOWN_PBE_ALGORITHM
  121)
(defc EVP_R_UNSUPORTED_NUMBER_OF_ROUNDS
  135)
(defc EVP_R_UNSUPPORTED_ALGORITHM
  156)
(defc EVP_R_UNSUPPORTED_CIPHER
  107)
(defc EVP_R_UNSUPPORTED_KEYLENGTH
  123)
(defc EVP_R_UNSUPPORTED_KEY_DERIVATION_FUNCTION
  124)
(defc EVP_R_UNSUPPORTED_KEY_SIZE
  108)
(defc EVP_R_UNSUPPORTED_PRF
  125)
(defc EVP_R_UNSUPPORTED_PRIVATE_KEY_ALGORITHM
  118)
(defc EVP_R_UNSUPPORTED_SALT_TYPE
  126)
(defc EVP_R_WRONG_FINAL_BLOCK_LENGTH
  109)
(defc EVP_R_WRONG_PUBLIC_KEY_TYPE
  110)


;;;; constants for message digests and HMAC

;; Message Digest 4
(defc MD4_DIGEST_LENGTH			16)

;; Message Digest 5
(defc MD5_DIGEST_LENGTH			16)

;; MDC2
(defc MDC2_DIGEST_LENGTH		#f)

;; SHA
(defc SHA_DIGEST_LENGTH			20)
(defc SHA224_DIGEST_LENGTH		28)
(defc SHA256_DIGEST_LENGTH		32)
(defc SHA384_DIGEST_LENGTH		48)
(defc SHA512_DIGEST_LENGTH		64)

;; RIPEMD 160
(defc RIPEMD160_DIGEST_LENGTH		20)

;; WHIRLPOOL
(defc WHIRLPOOL_DIGEST_LENGTH		64)

;; HMAC
(defc HMAC_MAX_MD_CBLOCK		128)


;;;; constants for encryption and decryption

;; AES
(defc AES_ENCRYPT		1)
(defc AES_DECRYPT		0)
(defc AES_BLOCK_SIZE		16)


;;;; miscellaneous

;; buffers
(defc BUF_F_BUF_MEMDUP		103)
(defc BUF_F_BUF_MEM_GROW	100)
(defc BUF_F_BUF_MEM_GROW_CLEAN	105)
(defc BUF_F_BUF_MEM_NEW		101)
(defc BUF_F_BUF_STRDUP		102)
(defc BUF_F_BUF_STRNDUP		104)


;;;; done

)

;;; end of file
;; Local Variables:
;; mode: scheme
;; End:
